Last Comment Bug 772201 - Webrtc breaks builds with symlinked objdirs
: Webrtc breaks builds with symlinked objdirs
Status: RESOLVED FIXED
[qa-]
:
Product: Core
Classification: Components
Component: WebRTC (show other bugs)
: Trunk
: All All
: -- normal (vote)
: mozilla16
Assigned To: [:jesup] on pto until 2016/7/5 Randell Jesup
:
Mentors:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-09 13:31 PDT by [:jesup] on pto until 2016/7/5 Randell Jesup
Modified: 2012-07-27 09:52 PDT (History)
4 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---
Has Regression Range: ---
Has STR: ---


Attachments
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs (3.61 KB, patch)
2012-07-09 21:17 PDT, [:jesup] on pto until 2016/7/5 Randell Jesup
jduell.mcbugs: feedback+
Details | Diff | Review
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs (2) (5.67 KB, patch)
2012-07-11 13:55 PDT, [:jesup] on pto until 2016/7/5 Randell Jesup
ted: review+
Details | Diff | Review

Description [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-09 13:31:18 PDT
The assumption is that this is due to use of relative paths to try to get 'out' of the objdir.  Likely the problem is largely in mozmake.py; perhaps in configure.in, media/webrtc/Makefile.in or related spots.
Comment 1 [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-09 21:17:13 PDT
Created attachment 640497 [details] [diff] [review]
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs
Comment 2 [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-09 21:20:43 PDT
Comment on attachment 640497 [details] [diff] [review]
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs

This appears to fix all the ../* paths in topsrcdir/srcdir/VPATH in gyp-generated Makefiles.

A grep on the makefiles showed no relative paths left after applying this patch and generating an objdir through a symlink, and it builds.
Comment 3 Jason Duell [:jduell] (needinfo? me) 2012-07-09 22:26:42 PDT
Comment on attachment 640497 [details] [diff] [review]
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs

Review of attachment 640497 [details] [diff] [review]:
-----------------------------------------------------------------

Fixes the bustage for me.  Thanks Randell!
Comment 4 Karsten Düsterloh 2012-07-10 11:34:14 PDT
FWIW: my Linux 64 bit SeaMonkey debug builds are also affected by this bug and this patch does help indeed.
Comment 5 [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-11 13:55:57 PDT
Created attachment 641185 [details] [diff] [review]
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs (2)
Comment 6 [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-11 14:02:47 PDT
Comment on attachment 641185 [details] [diff] [review]
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs (2)

Uses OS to decide to do absolute paths or not (always relative on windows to make it work with 'make' as well as 'pymake').

I'll fix the missing space in the first change before checkin
Comment 7 [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-11 16:39:08 PDT
All green on try!  https://tbpl.mozilla.org/?tree=Try&pusher=rjesup@wgate.com
Comment 8 Ted Mielczarek [:ted.mielczarek] 2012-07-12 15:05:11 PDT
Comment on attachment 641185 [details] [diff] [review]
remove relative topsrcdir/srcdir/etc paths from gyp-sourced Makefiles - fixes symlinked objdirs (2)

Review of attachment 641185 [details] [diff] [review]:
-----------------------------------------------------------------

::: media/webrtc/trunk/tools/gyp/pylib/gyp/generator/mozmake.py
@@ +197,5 @@
>  def Compilable(filename):
>    return os.path.splitext(filename)[1] in COMPILABLE_EXTENSIONS
>  
>  class MakefileGenerator(object):
> +  def __init__(self, target_dicts, data, options, depth, topsrcdir, relative_topsrcdir, relative_srcdir, output_dir,flavor):

nit: space after the comma
Comment 9 [:jesup] on pto until 2016/7/5 Randell Jesup 2012-07-12 15:16:01 PDT
nit fixed
https://hg.mozilla.org/integration/mozilla-inbound/rev/641d061b9e19
Comment 10 Ed Morley [:emorley] 2012-07-13 05:31:41 PDT
https://hg.mozilla.org/mozilla-central/rev/641d061b9e19

Note You need to log in before you can comment on or make changes to this bug.